﻿/////////////////////////////////////////////////////////////
//  
//  Javascript functions for the rotating Earth Clock Gadget
//  Earth Clock Gadget Version 1.0 2008/11
//  Written by CadWizard © 2008 all rights reserved.
//  cadwizardx@hotmail.com
//
//  Based on the Vista ® Orb Clock available on the
//  Microsoft Gadget Galley ® with a new spin added.
//  My Earth Clock has a rotating background written using Flash
//  Actionscript 3.0 ®, creating the illusion of the earth rotating
//  around an axis. The clock comes with 16 built in themes including
//  a rotating eight ball and a smiley face as well as a space station.
//  With a little Javascript, XML and image knowldge themes can easily
//  be added. Has all of the features of other clock gadgets, including
//  setting the time zone for each instance seperate from your local
//  time settings. You can assign each instance it's own unique name
//  and use a different theme for each.
//
//  Vista ® Orb Clock available on the Microsoft Gadget Galley ® at
//  http://vista.gallery.microsoft.com/vista/SideBar.aspx?mkt=en-us
//  Some code modified from sample code available on MSDN at
//  http://msdn.microsoft.com/en-us/library/aa965850(VS.85).aspx
//  Vista ®, SideBar ®, Gadget Galley ® and Sidebar Gadget ® are all
//  registered trademarks of Microsoft Corporation.
//  Copyright (c) 2006 Microsoft Corporation.  All rights reserved.
//  Microsoft Corporation can not be held liable for the use of this
//  application.
//
//  All images created using Adobe ® Fireworks CS3 ® licensed by
//  Adobe Systems Incorporated.
//  All Flash animations and dialogs created using Adobe ® Flash CS3 ®
//  licensed by Adobe Systems Incorporated.
//  Core application code written in Adobe ® Actionscript 3.0 ® for Flash ®
//  licensed by Adobe Systems Incorporated.
//  Adobe ®, Flash ®, Firworks ®, CS3 ® and Actionscript ®
//  are all registered trademarks of  Adobe Systems Incorporated.
//  Copyright (c) 2007 Adobe Systems Incorporated.  All rights reserved.
//
//  You have Royalty Free Rights to use and modify all code exposed by
//  by the author (CadWizard) for personal use only. You do have
//  permission to re-distribute this application for "free of charge" in
//  it's original form with all license's and code intact except as
//  part of a distributed CD/DVD or online library or compilation. You do not have
//  permission to distribute modified code, any images or flash swf files
//  without author's express written permission. No images and/or flash swf
//  files are to be used outside of this application for any purpose
//  be it personal,  private or commercial without the author's express
//  written permission.
//  May not be included in part or as a whole on any distributed
//  CD/DVD or online library or compilation without the
//  author's express written permission.
//
//  CadWizard is :
//  Larry Williams II
//  San Bernardino, CA
//  cadwizardx@hotmail.com
//  
/////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////
// variables

var tZones = System.Time.timeZones;
var tzCount = tZones.count;
var gfSettings = new GadgetFlashSettings();
System.Gadget.settingsUI = "clocksettings.html";
System.Gadget.onSettingsClosed = settingsClosed;
gfSettings.load();

/////////////////////////////////////////////////////////////
//
//  Gadget functions
//
/////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////
//  Function to get time using the current timezone setting
//  Returns array with system time for specified timezone

function getThisTime()
{
    var date;
    if (gfSettings.fgSettings.timezone >= 0)
    {
        date = new Date(System.Time.getLocalTime(tZones.item(gfSettings.fgSettings.timezone)));
    }
    else
    {
        date = new Date(System.Time.getLocalTime(System.Time.currentTimeZone));
    }

    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();

    return new Array(hours, minutes, seconds);
}

/////////////////////////////////////////////////////////////
//
//  Functions called from flash swf file.
//
/////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////
//  Returns array with system time for specified timezone
//  index or an array filled with -1's if index is invalid
//  to the calling flash swf file.


function getTimeAtZone(index)
{
    var idx = parseInt(index);
    if ((idx >= 0) && (idx < tzCount))
    {
        var res = getThisTime();
        return res;
    }
    else
    {
        return new Array(4, 20, 0);
    }
}

/////////////////////////////////////////////////////////////
//  Returns a FlashSettings object as defined by the gSettings
//  variable and a call to gSettings.load() to the calling flash
//  swf file.

function getFlashSettings()
{
    var fgs = new FlashGadgetSettings();
    fgs.themename = gfSettings.fgSettings.themename;
    fgs.clockname = gfSettings.fgSettings.clockname;
    fgs.timezone = parseInt(gfSettings.fgSettings.timezone);
    fgs.showseconds = gfSettings.fgSettings.showseconds;
    //AlertThis(fgs.themename);
    return fgs;
}


/////////////////////////////////////////////////////////////
//  Sets gadget background for the theme and time of day.

function setBackground(index)
{
    imgBackground.src = "url(images/" + gfSettings.fgSettings.themename + "_bkg" + index + ".png)";
}

/////////////////////////////////////////////////////////////
//
//  Gadget settings functions and objects.
//
/////////////////////////////////////////////////////////////


function settingsClosed(event)
{
    if (event.closeAction == event.Action.commit)
    {
	loadFlash();
    }
}


/////////////////////////////////////////////////////////////
//  Flash settings object to pass to flash swf file.

function FlashGadgetSettings()
{
    this.themename = "earth";
    this.clockname = "";
    this.timezone = -1;
    this.showseconds = true;
}

/////////////////////////////////////////////////////////////
//  Javascript object to load, save and store gadget settings.

function GadgetFlashSettings()
{
    this.load = LoadGadgetSettings;
    this.fgSettings = new FlashGadgetSettings();
}

/////////////////////////////////////////////////////////////
//  Function to load saved gadget settings if they exist.

function LoadGadgetSettings()
{
    
    if (System.Gadget.Settings.read("settingsexist"))
    {
        gfSettings.fgSettings.clockname = unescape(System.Gadget.Settings.readString("clockname"));
        gfSettings.fgSettings.themename = System.Gadget.Settings.readString("themename");
        gfSettings.fgSettings.timezone = parseInt(System.Gadget.Settings.read("timezone"));
        gfSettings.fgSettings.showseconds = System.Gadget.Settings.read("showseconds");
    }
}













