﻿/////////////////////////////////////////////////////////////
//  
//  Javascript functions for the rotating Earth Clock Gadget
//  Earth Clock Gadget Version 1.0 2008/11
//  Written by CadWizard © 2008 all rights reserved.
//  cadwizardx@hotmail.com



var timeZones = System.Time.timeZones;
var tzoneCount = timeZones.count;
var gSettings = new GadgetSettings();
var tempSettings = new FlashSettings();
System.Gadget.onSettingsClosing = settingsClosing;



/////////////////////////////////////////////////////////////
//  Function to validate saved themename before passing
//  to flash swf file.

function getTimeZones()
{
    var zonesarray = new Array(tzoneCount + 1);
    zonesarray[0] = {label:"Current Computer Time", data:-1};
    
    for (var i = 0; i < tzoneCount; i++)
    {
        zonesarray[i + 1]= {label:timeZones.item(i).displayName, data:i};
    }
    return zonesarray;
}

function getSettings()
{
    gSettings.load();
    var fs = new FlashSettings();
    fs.themename = tempSettings.themename = gSettings.fsettings.themename;
    fs.clockname = tempSettings.clockname = gSettings.fsettings.clockname;
    fs.timezone = tempSettings.timezone = parseInt(gSettings.fsettings.timezone);
    fs.showseconds = tempSettings.showseconds = gSettings.fsettings.showseconds;
    return fs;
}

/////////////////////////////////////////////////////////////
//  Recieves a FlashSettings object from the calling flash
//  swf file.

function storeSettings(obj)
{

    tempSettings.themename = obj.themename;
    tempSettings.clockname = obj.clockname;
    tempSettings.timezone = parseInt(obj.timezone);
    tempSettings.showseconds = obj.showseconds;
}


function openLicText()
{
    AlertThis("Created by CadWizard © 2008");
}


/////////////////////////////////////////////////////////////
//  Settings closing event handler

function settingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
	gSettings.fsettings.themename = tempSettings.themename;
	gSettings.fsettings.clockname = tempSettings.clockname;
	gSettings.fsettings.timezone = parseInt(tempSettings.timezone);
	gSettings.fsettings.showseconds = tempSettings.showseconds;
        gSettings.save();
    }
    event.cancel = false;

}

/////////////////////////////////////////////////////////////
//  Flash settings object to pass to flash swf file.

function FlashSettings()
{
    this.themename = "earth";
    this.clockname = "";
    this.timezone = -1;
    this.showseconds = true;
}

/////////////////////////////////////////////////////////////
//  Javascript object to load, save and store gadget settings.

function GadgetSettings()
{
    this.save = SaveSettings;
    this.load = LoadSettings;
    this.fsettings = new FlashSettings();
}

/////////////////////////////////////////////////////////////
//  Function to load saved gadget settings if they exist.

function LoadSettings()
{
    
    if (System.Gadget.Settings.read("settingsexist"))
    {
        gSettings.fsettings.clockname = unescape(System.Gadget.Settings.readString("clockname"));
        gSettings.fsettings.themename = System.Gadget.Settings.readString("themename");
        gSettings.fsettings.timezone = parseInt(System.Gadget.Settings.read("timezone"));
        gSettings.fsettings.showseconds = System.Gadget.Settings.read("showseconds");
    }
}

/////////////////////////////////////////////////////////////
//  Function to save gadget settings.

function SaveSettings()
{
    System.Gadget.Settings.write("settingsexist", true);
    System.Gadget.Settings.writeString("clockname", escape(gSettings.fsettings.clockname));
    System.Gadget.Settings.writeString("themename", gSettings.fsettings.themename);
    System.Gadget.Settings.write("timezone", gSettings.fsettings.timezone);
    System.Gadget.Settings.write("showseconds", gSettings.fsettings.showseconds);
    //AlertThis(System.Gadget.Settings.readString("themename"));
}

